package com.qa.utilities;

import java.io.File;

import io.restassured.RestAssured;
import io.restassured.http.ContentType;
import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;
import io.restassured.specification.RequestSpecification;
import static io.restassured.RestAssured.given;

public class RestUtil {
	//Global Setup Variables
    public static String path; //Rest request path
    static RequestSpecification request= RestAssured.given();
		/*
	    ***Sets Base URI***
	    Before starting the test, we should set the RestAssured.baseURI
	    */
	    public static void setBaseURI (String baseURI){
	        RestAssured.baseURI = baseURI;
	    }
	    /*
	     ***Sets ContentType***
	     We should set content type as JSON or XML before starting the test
	     */
	     public static void setContentType (String Type){
	    	 request.with().contentType(Type);
	     }
	  
	     /*
	     ***search query path of first example***
	     It is  equal to "barack obama/videos.json?num_of_videos=4"
	     */
	     public static String  createSearchQueryPath(String searchTerm, String jsonPathTerm, String param, String paramValue) {
	         path = "?" + param + "=" + paramValue;
	         return path;
	     }
	     /*
	      ***Returns response***
	      We send "path" as a parameter to the Rest Assured'a "get" method
	      and "get" method returns response of API
	      */
	      public static Response getResponse() {
	          //System.out.print("path: " + path +"\n");
	          return RestAssured.get(path);
	      }
	      /*
	       ***Returns JsonPath object***
	       * First convert the API's response to String type with "asString()" method.
	       * Then, send this String formatted json response to the JsonPath class and return the JsonPath
	       */
	       public static JsonPath getJsonPath (Response res) {
	           String json = res.asString();
	           //System.out.print("returned json: " + json +"\n");
	           return new JsonPath(json);
	       }
	       public static void setreqPayload(File file) {
	    	   request.given().body(file);
	       }
	       public static Response setPostwebserviceUrl(String baseuri,String resourceuri) {
	    	   String url = baseuri.concat(resourceuri);
	    	   url= url.replaceAll("\"", "");
	    	   System.out.println(url);
	    	   return request.when().post(url);
	       }
	       public static void setGetResourceUri(String resourceuri) {
	    	   RestAssured.when().get(resourceuri);
	       }
}
